diff --git a/doc/guides/nics/overview.rst b/doc/guides/nics/overview.rst
index 542479a..b5d1c2c 100644
--- a/doc/guides/nics/overview.rst
+++ b/doc/guides/nics/overview.rst
@@ -74,39 +74,39 @@ Most of these differences are summarized below.
 
 .. table:: Features availability in networking drivers
 
-   ==================== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
-   Feature              a b b b c e e e i i i i i i i i i i f f m m m n n p r s v v v v x
-                        f n n o x 1 n n 4 4 4 4 g g x x x x m m l l p f u c i z h i i m e
-                        p x x n g 0 a i 0 0 0 0 b b g g g g 1 1 x x i p l a n e o r r x n
-                        a 2 2 d b 0   c e e e e   v b b b b 0 0 4 5 p   l p g d s t t n v
-                        c x x i e 0       . v v   f e e e e k k     e         a t i i e i
-                        k   v n           . f f       . v v   .               t   o o t r
-                        e   f g           .   .       . f f   .               a     . 3 t
-                        t                 v   v       v   v   v               2     v
-                                          e   e       e   e   e                     e
-                                          c   c       c   c   c                     c
-   ==================== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
-   link status                  X       X X                                   X X
-   link status event                    X X                                     X
-   queue status event                                                           X
-   Rx interrupt                         X X X X
-   queue start/stop             X   X   X X X X                               X
+   ==================== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
+   Feature              a b b b c e e e i i i i i i i i i i f f f f m m m n n p r s v v v v x
+                        f n n o x 1 n n 4 4 4 4 g g x x x x m m m m l l p f u c i z h i i m e
+                        p x x n g 0 a i 0 0 0 0 b b g g g g 1 1 1 1 x x i p l a n e o r r x n
+                        a 2 2 d b 0   c e e e e   v b b b b 0 0 0 0 4 5 p   l p g d s t t n v
+                        c x x i e 0       . v v   f e e e e k k k k     e         a t i i e i
+                        k   v n           . f f       . v v   . v v               t   o o t r
+                        e   f g           .   .       . f f   . f f               a     . 3 t
+                        t                 v   v       v   v   v   v               2     v
+                                          e   e       e   e   e   e                     e
+                                          c   c       c   c   c   c                     c
+   ==================== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
+   link status                  X       X X                                       X X
+   link status event                    X X                                         X
+   queue status event                                                               X
+   Rx interrupt                         X X X X             X X X X
+   queue start/stop             X   X   X X X X             X X X X               X
    MTU update                   X   X
-   jumbo frame                  X   X   X X X X
-   scattered Rx                 X   X   X X X X                               X
+   jumbo frame                  X   X   X X X X             X X X X
+   scattered Rx                 X   X   X X X X             X X X X               X
    LRO
-   TSO                          X   X   X X X X
-   promiscuous mode             X       X X X X                               X
-   allmulticast mode            X       X X X X                               X
-   unicast MAC filter                   X X X X
-   multicast MAC filter                 X X X X
-   RSS hash                     X   X   X X X X
-   RSS key update                   X   X X X X
-   RSS reta update                  X   X X X X
-   VMDq                                 X X
+   TSO                          X   X   X X X X             X X X X
+   promiscuous mode             X       X X X X             X X                   X
+   allmulticast mode            X       X X X X             X X                   X
+   unicast MAC filter                   X X X X             X X
+   multicast MAC filter                 X X X X             X X
+   RSS hash                     X   X   X X X X             X X X X
+   RSS key update                   X   X X X X             X X X X
+   RSS reta update                  X   X X X X             X X X X
+   VMDq                                 X X                 X X
    SR-IOV                           X   X X
    DCB                                  X X
-   VLAN filter                          X X X X
+   VLAN filter                          X X X X             X X
    ethertype filter                     X X
    n-tuple filter
    SYN filter
@@ -117,32 +117,32 @@ Most of these differences are summarized below.
    flow control                 X       X X
    rate limitation
    traffic mirroring                    X X
-   CRC offload                  X   X   X   X
-   VLAN offload                 X   X   X   X
+   CRC offload                  X   X   X   X               X X X X
+   VLAN offload                 X   X   X   X               X X X X
    QinQ offload                         X   X
-   L3 checksum offload          X   X   X   X
-   L4 checksum offload          X   X   X   X
+   L3 checksum offload          X   X   X   X               X X X X
+   L4 checksum offload          X   X   X   X               X X X X
    inner L3 checksum                X   X   X
    inner L4 checksum                X   X   X
-   packet type parsing          X       X   X
+   packet type parsing          X       X   X               X X X X
    timesync                             X X
-   basic stats                  X   X   X X X X                               X X
-   extended stats                   X   X X X X
-   stats per queue              X                                             X
+   basic stats                  X   X   X X X X             X X X X               X X
+   extended stats                   X   X X X X             X X X X
+   stats per queue              X                                                 X
    EEPROM dump
    registers dump
    multiprocess aware                   X X X X
    BSD nic_uio                  X       X X X X
-   Linux UIO                    X   X   X X X X
-   Linux VFIO                   X       X X X X
-   other kdrv                                                                 X
+   Linux UIO                    X   X   X X X X             X X X X
+   Linux VFIO                   X       X X X X             X X X X
+   other kdrv                                                                     X
    ARMv7
    ARMv8
    Power8
    TILE-Gx
-   x86-32                       X   X   X X X X                                 X
-   x86-64                       X   X   X X X X                               X X
-   usage doc                    X                                             X
+   x86-32                       X   X   X X X X             X X X X                 X
+   x86-64                       X   X   X X X X             X X X X               X X
+   usage doc                    X                                                 X
    design doc
    perf doc
    ==================== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =